from thingz import touch_n
from thingz import touch_s
from thingz import button_b
import time
import simple_wifi
from thingz import led
import supervisor


wifi1 = simple_wifi.SimpleWifi()
http = simple_wifi.SimpleHttp(wifi1)

def index_page():
    thgz_response = ''
    thgz_response += ''.join([str(x5) for x5 in ['Lumière=', led.read_light_level(), '']]) + '</br>'
    http.respond_with_html(thgz_response, template="autoreload.html", tags=[("reload", 2000)])


http.add_web_page_url("", index_page)
web_pages = lambda: http.handle_web_pages()
supervisor.set_background_user_callback(web_pages)

def menu_ip():
    global choix_ip
    print('Adresse IP du Capteur:')
    print('1. 192.168.0.5')
    print('2. 192.168.0.7')
    print('3. 192.168.0.9')
    print('4. Retour menu')
    print('Choix avec bouton tactile')
    print('Validation bouton B')
    print(''.join([str(x) for x in ['Choix=', choix_ip, '']]))

def menu():
    global choix_menu, choix_ip
    if touch_n.was_touched():
        if choix_menu <= 2:
            choix_menu = (choix_menu if isinstance(choix_menu, int or float) else 0) + 1
            menu_gene()
    if touch_s.was_touched():
        if choix_menu > 1:
            choix_menu = (choix_menu if isinstance(choix_menu, int or float) else 0) + -1
            menu_gene()
    if button_b.was_pressed():
        if choix_menu == 1:
            print('Liste SSID WIFI')
            nb_ssid=0
            for network in wifi1.scan():
                print('SSID=', network.ssid, ' RSSI=', network.rssi)
                nb_ssid +=1
            
            if (7-nb_ssid)>0:
                for i in range(7-nb_ssid):
                    print('')
        else:
            if choix_menu == 2:
                menu_ip()
                choix_ip2()
            else:
                demarrage()

def adresse_IP():
    global choix_ip, adresse_ip
    if choix_ip == 1:
        adresse_ip = '192.168.0.5'
    else:
        if choix_ip == 2:
            adresse_ip = '192.168.0.7'
        else:
            if choix_ip == 3:
                adresse_ip = '192.168.0.9'

def choix_ip2():
    global choix_ip, adresse_ip
    while not button_b.was_pressed():
        if touch_n.was_touched():
            if choix_ip <= 3:
                choix_ip = (choix_ip if isinstance(choix_ip, int or float) else 0) + 1
                menu_ip()
        if touch_s.was_touched():
            if choix_ip > 1:
                choix_ip = (choix_ip if isinstance(choix_ip, int or float) else 0) + -1
                menu_ip()
    if choix_ip == 4:
        menu_gene()
        menu()
    else:
        adresse_IP()
        print(''.join([str(x2) for x2 in ['Ip choisie=', adresse_ip, '']]))
        time.sleep((2)*1)

def menu_gene():
    global choix_menu, adresse_ip
    print('Menu capteur connecté')
    print(''.join([str(x3) for x3 in ['IP capteur=', adresse_ip, '']]))
    print('1. Liste des SSID Wifi')
    print('2. Paramétrer le capteur')
    print('3. Démarrer le capteur')
    print('Choix avec bouton tactile')
    print('Validation avec bouton B')
    print(''.join([str(x4) for x4 in ['Choix=', choix_menu, '']]))

def demarrage():
    global adresse_ip, message
    print('Démarrage du capteur....')
    wifi1.connect('MSPC', '12345678', static_ip=adresse_ip)
    message="o"
    while not(message == "c"):
        message = wifi1.receive(reuseClient=True)
        print(message)
        if message == 't':
            led.set_colors(255, 255, 255)
            t=int(led.read_light_level())
            print("lum=",t)
            wifi1.send_to_client(' lum='+str(t)+'\r\n')
            led.set_colors(0, 0, 0)
        else:
            if message == 'c':
                wifi1.close()
                menu_gene()

choix_menu = 1
choix_ip = 1
adresse_ip = 'Non choisie!'
menu_gene()

while True:
    menu()
