from thingz import touch_n
from thingz import touch_s
from thingz import button_b
from thingz import button_a

import time
import ssl
import socketpool
import wifi
import adafruit_minimqtt.adafruit_minimqtt as MQTT
from thingz import led

# BacPro MSPC
# Introduction à la mise en œuvre des systèmes communicants
# TP n°2
# découverte de l'utilisation du protocole MQTT
# Utilisation du capteur de lumière
# version du 16/02/2022

# Renseigner l'ID Client copié sur le site Hivemq
clientid="clientId-1MLimi6Imq"

# Renseigner les données du point d'accès Wifi
SSID="SFR_B5F8"
mot_passe_SSID="45cdmi6ygm24wdrd5nxa"

# topic utilisé pour la publication d'un lessage au Broker
photocell_feed = "mspc/lum"

### Code ###
def connected(client, userdata, flags, rc):
    # Utilisée lorsque que le client est connecté au Broker
    # Le client s'inscrit au topic du Broker.
    client.subscribe(photocell_feed)
    print("Connecté au Broker Hivemq! ")

def disconnected(client, userdata, rc):
    # Si déconnexion du client
    print("Déconnecté du broker!")

def message(client, topic, message):
    # envoi de la donné au topic
    print("Nouveau message avec le topic {0}: {1}".format(topic, message))

def menu_gene():
    global choix_menu
    print('Menu capteur connecté')
    print('1. Adresse IP')
    print('2. Valeurs capteur')
    print('3. Lancer la publication')
    print('Choix avec bouton tactile')
    print('Validation avec bouton B')
    print('')
    print(''.join([str(x4) for x4 in ['Choix=', choix_menu, '']]))
    
def menu():
    global choix_menu
    if touch_n.was_touched():
        if choix_menu <= 2:
            choix_menu = (choix_menu if isinstance(choix_menu, int or float) else 0) + 1
            menu_gene()
    if touch_s.was_touched():
        if choix_menu > 1:
            choix_menu = (choix_menu if isinstance(choix_menu, int or float) else 0) + -1
            menu_gene()
    if button_b.was_pressed():
        if choix_menu == 1:
            print('Adresse IP='+str(wifi.radio.ipv4_address))
            print('Appuyer bouton A')
            for i in range(6):
                print('')
            while not(button_a.was_pressed()):
                pass
            menu_gene()
        else:
            if choix_menu == 2:
                print('Appuyer bouton A')
                print('pour revenir au menu')
                time.sleep(5)
                while not(button_a.was_pressed()):
                    print('Val capt lum='+str(led.read_light_level()))
                menu_gene()
            else:
                demarrage()

def demarrage():
    # Création d'un pool de sockets
    pool = socketpool.SocketPool(wifi.radio)

    # Définition du client MQTT pour inscription au Broker
    mqtt_client = MQTT.MQTT(
        broker="broker.mqttdashboard.com",
        port=1883,
        username="mspc",
        password=clientid,
        socket_pool=pool,
        ssl_context=ssl.create_default_context(),
    )

    # Mise en place des méthodes pour la gestion du protocole MQTT
    mqtt_client.on_connect = connected
    mqtt_client.on_disconnect = disconnected
    mqtt_client.on_message = message

    # Connexion du client au Broker MQTT.
    print("Connexion au Broker Hivemq...")
    mqtt_client.connect()

    while True:
        # Interrogation de file d'attente des messages
        mqtt_client.loop()
        lumiere=led.read_light_level()
        # envoi du nouveau message
        print("Envoi de la donnée: %d..." % lumiere)
        mqtt_client.publish(photocell_feed, lumiere)
        print("Envoyée!")
        time.sleep(5)

print("Connexion du capteur")
print("à Internet ...")
try:
    wifi.radio.connect(SSID, mot_passe_SSID)
    print("Connecté à Internet")
    time.sleep(5)
    choix_menu = 1
    menu_gene()
    while True:
        menu()
except:
    print("Impossible de connecter")
    print("à Internet!")
    print("Revoir le paramétrages")
    